'              A D & D  C H A R A C T E R  G E N E R A T O R
'                           registered version
'
'                   Copyright (c) 1993, Danny Abramson
'              No part of this program may be altered without
'                        consent of Danny Abramson.
'
'
'
'    THIS PROGRAM QUICKLY GENERATES A GOOD FAST CHARACTER FOR AD&D
'                         USING ANY DICE METHOD
'
'
'    DIRECTIONS:
'
'    To run the program select START from the RUN menu, or press F5
'    If you have any questions refer to AD&D.TXT for a step-by-step
'    walk through of how to create a character using this program.
'    To quit this code listing select EXIT from the FILE menu.
'
'
'        Have fun with a character the world will never forget!






DECLARE FUNCTION rolldice% (num%, sides%)
DECLARE FUNCTION roll5% ()
DECLARE FUNCTION die5%
DECLARE SUB abil ()
DECLARE SUB races ()
DECLARE SUB classes ()
DECLARE SUB aligns ()
DECLARE SUB savthrows ()
DECLARE SUB hits ()
DECLARE SUB mss ()
DECLARE SUB save ()
DECLARE SUB saved ()
OPTION BASE 1
DIM SHARED ability$(6)
DIM SHARED ability%(6)
DIM SHARED race$(6)
DIM SHARED class$(8)
DIM SHARED align$(9)
DIM SHARED savthrow$(5)
DIM SHARED savthrow%(5)
COMMON SHARED race%, gender$, height%, weight%, age%, class%, primereq%
COMMON SHARED align%, hit%, move%, wp%, nwp%, money%
COMMON SHARED name$, hair$, eyes$, religion$, siblings&, social$

10000
ability$(1) = "Strength"
ability$(2) = "Dexterity"
ability$(3) = "Constitution"
ability$(4) = "Intelligence"
ability$(5) = "Wisdom"
ability$(6) = "Charisma"
race$(1) = "Dwarf"
race$(2) = "Elf"
race$(3) = "Gnome"
race$(4) = "Half-elf"
race$(5) = "Halfling"
race$(6) = "Human"
class$(1) = "Fighter"
class$(2) = "Paladin"
class$(3) = "Ranger"
class$(4) = "Mage"
class$(5) = "Cleric"
class$(6) = "Druid"
class$(7) = "Thief"
class$(8) = "Bard"
align$(1) = "Lawful Good"
align$(2) = "Lawful Neutral"
align$(3) = "Lawful Evil"
align$(4) = "Neutral Good"
align$(5) = "True Neutral"
align$(6) = "Neutral Evil"
align$(7) = "Chaotic Good"
align$(8) = "Chaotic Neutral"
align$(9) = "Chaotic Evil"
savthrow$(1) = "Paralyze/Poison"
savthrow$(2) = "Rod, Staff, or Wand"
savthrow$(3) = "Petrify/Polymorph"
savthrow$(4) = "Breath Weapon    "
savthrow$(5) = "Spells           "

CLS
PRINT "                        AD&D CHARACTER GENERATOR"
PRINT "                  Copyright (c) 1993, Danny Abramson"
PRINT
PRINT
PRINT "   1.  Create a new character"
PRINT "   2.  Open a previously saved character"
PRINT
INPUT "Choose one of the previous options:  ", menu%
PRINT
SELECT CASE menu%
     CASE 1
          GOTO 44
     CASE 2
          saved
          GOTO 10000
END SELECT
44
abil
races
classes
aligns
savthrows
hits

IF race% = 1 OR race% = 3 OR race% = 5 THEN
     move% = 6
ELSE
     move% = 12
END IF

500
CLS
PRINT "                       YOUR CHARACTER SUMMARY"
PRINT
PRINT
PRINT "ABILITY SCORES:", "SAVING THROWS:"
FOR i% = 1 TO 5
     PRINT ability$(i%), ability%(i%), savthrow$(i%), savthrow%(i%)
NEXT i%
PRINT ability$(6), ability%(6)
PRINT
PRINT "NAME  : ", name$
IF primereq% = -1 THEN
     PRINT "CLASS : ", class$(class%); ; " (Prime Requisites Met)"
ELSE
     PRINT "CLASS : ", class$(class%)
END IF
PRINT "ALIGNMENT: ", align$(align%)
PRINT "THAC0: ", 20
PRINT "HIT POINTS: ", hit%
PRINT "BASE MOVEMENT:"; move%
PRINT "WEAPON PROFICIENCIES   : "; wp%
PRINT "NONWEAPON PROFICIENCIES: "; nwp%
PRINT "STARTING FUNDS:"; money%; " Gold Pieces"
PRINT
INPUT "Press Enter for more"; d%
CLS
PRINT
PRINT
PRINT "HAIR:", hair$
PRINT "EYES:", eyes$
PRINT "RELIGION:", religion$
PRINT "SIBLINGS:", siblings&
PRINT "SOCIAL CLASS:", social$
PRINT "RACE  : ", race$(race%)
PRINT "GENDER: ", gender$
PRINT "HEIGHT: ", height%; " inches,  ("; height% \ 12; "feet, "; height% MOD 12; "inches)"
PRINT "WEIGHT: ", weight%; " lbs."
PRINT "AGE   : ", age%; " years"
PRINT
PRINT
INPUT "Would you like to see this information again (Y, N)"; again$
again$ = UCASE$(again$)
IF again$ = "Y" THEN GOTO 500 ELSE
PRINT
INPUT "Would you like this information printed out (Y, N)"; lprint$
lprint$ = UCASE$(lprint$)
IF lprint$ = "Y" THEN
        LPRINT "                 AD&D CHARACTER GENERATOR CHARACTER SUMMARY"
        LPRINT
        LPRINT
        LPRINT "ABILITY SCORES:", "SAVING THROWS:"
        FOR i% = 1 TO 5
                LPRINT ability$(i%), ability%(i%), savthrow$(i%), savthrow%(i%)
        NEXT i%
        LPRINT ability$(6), ability%(6)
        LPRINT
        LPRINT "NAME  : ", name$
        IF primereq% = -1 THEN
               LPRINT "CLASS : ", class$(class%); ; " (Prime Requisites Met)"
        ELSE
               LPRINT "CLASS : ", class$(class%)
        END IF
        LPRINT "ALIGNMENT: ", align$(align%)
        LPRINT "THAC0: ", 20
        LPRINT "HIT POINTS: ", hit%
        LPRINT "BASE MOVEMENT:"; move%
        LPRINT "WEAPON PROFICIENCIES   : "; wp%
        LPRINT "NONWEAPON PROFICIENCIES: "; nwp%
        LPRINT "STARTING FUNDS:"; money%; " Gold Pieces"
        LPRINT
        LPRINT
        LPRINT "HAIR:", hair$
        LPRINT "EYES:", eyes$
        LPRINT "RELIGION:", religion$
        LPRINT "SIBLINGS:", siblings&
        LPRINT "SOCIAL CLASS:", social$
        LPRINT "RACE  : ", race$(race%)
        LPRINT "GENDER: ", gender$
        LPRINT "HEIGHT: ", height%; " inches,  ("; height% \ 12; "feet, "; height% MOD 12; "inches)"
        LPRINT "WEIGHT: ", weight%; " lbs."
        LPRINT "AGE   : ", age%; " years"
        LPRINT CHR$(12)
END IF
PRINT
INPUT "Would you like to save this character (Y, N)?", sve$
        IF sve$ = "y" THEN save
        IF sve$ = "Y" THEN save
IF class% = 4 OR 5 OR 6 OR 7 OR 8 THEN
        INPUT "Would you like to print a spell sheet (Y, N)", ss$
        IF ss$ = "y" THEN mss
        IF ss$ = "Y" THEN mss
END IF
PRINT
INPUT "Would you like to create another character (Y, N)", create$
IF create$ = "y" THEN GOTO 10000
IF create$ = "Y" THEN GOTO 10000
CLS
SYSTEM
END

SUB abil
DIM roll%(12)
work$ = "working. . ."
100
PRINT "Dice Methods:"
PRINT "1)  Roll 3d6 six time, in order."
PRINT "2)  Roll 3d6 twice per ability, select either."
PRINT "3)  Roll 3d6 six times and assign to abilities as desired."
PRINT "4)  Roll 3d6 twelve times and assign any six as desired."
PRINT "5)  Roll 4d6 (ignore lowest die) six times, assign as desired."
PRINT "6)  Roll 7d6, assign dice to base scores of 8 in each ability."
PRINT
INPUT "What dice method would like to use?  ", m%
PRINT
IF m% = 1 THEN GOTO 1
IF m% = 2 THEN GOTO 2
IF m% = 3 THEN GOTO 3
IF m% = 4 THEN GOTO 4
IF m% = 5 THEN GOTO 5
IF m% = 6 THEN GOTO 6
IF m% = 0 THEN END
PRINT "please enter a number from 1 to 6"
GOTO 100
1
30
PRINT "What would you like to be the"
INPUT "lowest ability score in your character?  ", lowroll%
IF lowroll% >= 18 THEN GOTO 30
PRINT
PRINT

a% = 6

RANDOMIZE TIMER
FOR i% = 2 TO a%
     roll%(i%) = INT(RND * 6) + INT(RND * 6) + INT(RND * 6) + 3
NEXT i%
PRINT work$
PRINT

DO
     FOR i% = 1 TO a%
          roll%(i%) = roll%(i% + 1)
     NEXT i%
     roll%(a%) = INT(RND * 6) + INT(RND * 6) + INT(RND * 6) + 3
     numhigh% = 0
     FOR i% = 1 TO a%
          IF roll%(i%) >= lowroll% THEN numhigh% = numhigh% + 1
     NEXT i%
LOOP UNTIL numhigh% >= a%

FOR i% = 1 TO a%
     PRINT "Your "; ability$(i%); " score is "; roll%(i%)
     ability%(i%) = roll%(i%)
     PRINT
NEXT i%
PRINT
PRINT



GOTO 99



2
31
PRINT "What would you like to be the"
INPUT "lowest ability score in your character?  ", lowroll%
IF lowroll% >= 18 THEN GOTO 31
PRINT
PRINT

a% = 6

RANDOMIZE TIMER
FOR i% = 2 TO a%
     roll1% = INT(RND * 6) + INT(RND * 6) + INT(RND * 6) + 3
     roll2% = INT(RND * 6) + INT(RND * 6) + INT(RND * 6) + 3
     IF roll1% > roll2% THEN roll%(i%) = roll1% ELSE roll%(i%) = roll2%

NEXT i%
PRINT work$
PRINT

DO
     FOR i% = 1 TO a%
          roll%(i%) = roll%(i% + 1)
     NEXT i%
     roll1% = INT(RND * 6) + INT(RND * 6) + INT(RND * 6) + 3
     roll2% = INT(RND * 6) + INT(RND * 6) + INT(RND * 6) + 3
     IF roll1% > roll2% THEN roll%(a%) = roll1% ELSE roll%(a%) = roll2%
     numhigh% = 0
     FOR i% = 1 TO a%
          IF roll%(i%) >= lowroll% THEN numhigh% = numhigh% + 1
     NEXT i%
LOOP UNTIL numhigh% >= a%

FOR i% = 1 TO a%
     PRINT "Your "; ability$(i%); " score is "; roll%(i%)
     PRINT
     ability%(i%) = roll%(i%)
NEXT i%
PRINT
PRINT



GOTO 99


3
32
PRINT "What would you like to be the"
INPUT "lowest ability score in your character?  ", lowroll%
IF lowroll% >= 18 THEN GOTO 32
a% = 6

RANDOMIZE TIMER
FOR i% = 2 TO a%
     roll%(i%) = INT(RND * 6) + INT(RND * 6) + INT(RND * 6) + 3
NEXT i%
PRINT work$
PRINT

DO
     FOR i% = 1 TO a%
          roll%(i%) = roll%(i% + 1)
     NEXT i%
     roll%(a%) = INT(RND * 6) + INT(RND * 6) + INT(RND * 6) + 3
     numhigh% = 0
     FOR i% = 1 TO a%
          IF roll%(i%) >= lowroll% THEN numhigh% = numhigh% + 1
     NEXT i%
LOOP UNTIL numhigh% >= a%

FOR i% = 1 TO a%
     PRINT "One of your scores is "; roll%(i%)
     PRINT
NEXT i%
PRINT
PRINT



GOTO 7
GOTO 99

4
33
PRINT "What would you like to be the"
INPUT "lowest ability score in your character?  ", lowroll%
IF lowroll% >= 18 THEN GOTO 33
PRINT work$
PRINT
PRINT
PRINT
PRINT
a% = 6

RANDOMIZE TIMER
FOR i% = 1 TO 12
     roll%(i%) = INT(RND * 6) + INT(RND * 6) + INT(RND * 6) + 3
NEXT i%
13
numhigh% = 0
FOR i% = 1 TO 12
     IF roll%(i%) >= lowroll% THEN numhigh% = numhigh% + 1
NEXT i%

IF numhigh% >= 6 THEN GOTO 14

FOR i% = 1 TO 11
     roll%(i%) = roll%(i% + 1)
NEXT i%
roll%(12) = INT(RND * 6) + INT(RND * 6) + INT(RND * 6) + 3
GOTO 13

14
FOR i% = 1 TO 6
     FOR j% = 11 TO i% STEP -1
          IF roll%(j%) < roll%(j% + 1) THEN
               temp% = roll%(j%)
               roll%(j%) = roll%(j% + 1)
               roll%(j% + 1) = temp%
           END IF
     NEXT j%
NEXT i%

FOR i% = 1 TO 6
     PRINT roll%(i%); "                 this is one ability score"
     PRINT
NEXT i%
PRINT
PRINT



GOTO 7
GOTO 99


5
a% = 6
34
PRINT "What would you like to be the lowest possible"
INPUT "ability score in your character?  ", lowroll%
IF lowroll% >= 18 THEN GOTO 34
RANDOMIZE TIMER
FOR i% = 2 TO a%
     roll%(i%) = roll5%
NEXT i%
PRINT work$
PRINT

DO
     FOR i% = 1 TO a%
          roll%(i%) = roll%(i% + 1)
     NEXT i%
     roll%(a%) = roll5%
     numhigh% = 0
     FOR i% = 1 TO a%
          IF roll%(i%) >= lowroll% THEN numhigh% = numhigh% + 1
     NEXT i%
LOOP UNTIL numhigh% >= a%

FOR i% = 1 TO a%
     PRINT "One of your scores is "; roll%(i%)
     PRINT
NEXT i%
PRINT
PRINT



GOTO 7
GOTO 99

6
35
PRINT "What would you like to be the"
INPUT "lowest ability addition in your character?  ", lowroll%
IF lowroll% >= 18 THEN GOTO 35
a% = 7
RANDOMIZE TIMER
FOR i% = 2 TO a%
     roll%(i%) = INT(RND * 6) + 1
NEXT i%
PRINT work$
PRINT

DO
     FOR i% = 1 TO a%
          roll%(i%) = roll%(i% + 1)
     NEXT i%
     roll%(a%) = INT(RND * 6) + 1
     numhigh% = 0
     FOR i% = 1 TO a%
          IF roll%(i%) >= lowroll% THEN numhigh% = numhigh% + 1
     NEXT i%
LOOP UNTIL numhigh% >= a%



done% = 0
FOR i% = 1 TO 6
     ability%(i%) = 8
NEXT i%
DO
     CLS
     FOR i% = 1 TO 6
          PRINT ability$(i%); " is now "; ability%(i%)
     NEXT i%
     PRINT
     PRINT "Available rolls are: ";
     FOR i% = 1 TO 7
          IF roll%(i%) > 0 THEN PRINT roll%(i%);
     NEXT i%
     PRINT
     INPUT "Add which roll? ", r%
     INPUT "To which ability (Use the first two letters) ", b$
     roll% = 0
     FOR i% = 1 TO 7
          IF roll%(i%) > 0 AND roll%(i%) = r% THEN
               roll% = roll%(i%)
               rn% = i%
               i% = 8
          END IF
     NEXT i%
     ab% = 0
     FOR i% = 1 TO 6
          IF LCASE$(LEFT$(ability$(i%), 2)) = LCASE$(b$) AND ability%(i%) + roll% <= 18 THEN
               ab% = i%
               ability%(i%) = ability%(i%) + roll%
               roll%(rn%) = 0
               i% = 8
          END IF
     NEXT i%
     IF r% = 0 AND b$ = "" THEN done% = 1
     IF roll%(1) + roll%(2) + roll%(3) + roll%(4) + roll%(5) + roll%(6) + roll%(7) = 0 THEN
          done% = 1
     END IF
LOOP UNTIL done% = 1
CLS
PRINT "Final Scores: "
PRINT
FOR i% = 1 TO 6
    PRINT ability$(i%); " is "; ability%(i%)
NEXT i%

GOTO 99

7
'Ask which roll to use where.  Used by methods 3, 4, and 5
FOR i% = 1 TO 6
    DO
    PRINT "What is your "; ability$(i%); " score ";
    INPUT a%
    anum% = 0
    FOR j% = 1 TO 6
     IF a% > 0 AND a% = roll%(j%) THEN
          anum% = j%
          j% = 7
     END IF
    NEXT j%
    LOOP UNTIL anum% > 0
    ability%(i%) = roll%(anum%)
    roll%(anum%) = 0
NEXT i%
99
PRINT
INPUT "Press Enter to continue "; i%

END SUB

SUB aligns
numok% = 0
DIM okaligns%(9)

IF class% = 1 OR class% = 4 OR class% = 5 OR class% = 6 THEN
FOR i% = 1 TO 9
     okaligns%(i%) = i%
NEXT i%
numok% = 9
END IF

IF class% = 2 THEN
     PRINT "You are Lawful Good"
     INPUT "Press Enter to continue", a%
     align% = 1
END IF

IF class% = 3 THEN
     okaligns%(1) = 1
     okaligns%(2) = 4
     okaligns%(3) = 7
     numok% = 3
END IF

IF class% = 7 THEN
FOR i% = 1 TO 8
     okaligns%(i%) = i% + 1
NEXT i%
numok% = 8
END IF

IF class% = 8 THEN
     okaligns%(1) = 2
     okaligns%(2) = 4
     okaligns%(3) = 5
     okaligns%(4) = 6
     okaligns%(5) = 8
     numok% = 5
END IF

IF numok% = 0 GOTO 299


CLS
PRINT "Do you want to be a "
FOR i% = 1 TO numok%
     PRINT i%; ") "; align$(okaligns%(i%))
NEXT i%
250

PRINT
PRINT "Enter the number (1 to"; numok%; ")";
INPUT a%
IF a% = 0 THEN END
IF a% > numok% THEN GOTO 250

align% = okaligns%(a%)

299

END SUB

SUB classes
numok% = 0
DIM okclass%(8)
DIM prime%(8)

prime%(1) = ability%(1) >= 16
prime%(2) = ability%(1) >= 16 AND ability%(6) >= 16
prime%(3) = ability%(1) >= 16 AND ability%(2) >= 16 AND ability%(5) >= 16
prime%(4) = ability%(4) >= 16
prime%(5) = ability%(5) >= 16
prime%(6) = ability%(5) >= 16 AND ability%(6) >= 16
prime%(7) = ability%(2) >= 16
prime%(8) = ability%(2) >= 16 AND ability%(6) >= 16

IF ability%(1) >= 9 THEN
     numok% = 1
     okclass%(1) = 1
END IF

IF race% = 6 AND ability%(1) >= 12 AND ability%(3) >= 9 AND ability%(5) >= 13 AND ability%(6) >= 17 THEN
     numok% = numok% + 1
     okclass%(numok%) = 2
END IF

IF race% = 2 OR race% = 4 OR race% = 6 THEN
     IF ability%(1) >= 13 AND ability%(2) >= 13 AND ability%(3) >= 13 AND ability%(5) >= 13 THEN
          numok% = numok% + 1
          okclass%(numok%) = 3
     END IF
END IF

IF race% = 2 OR race% = 4 OR race% = 6 THEN
     IF ability%(4) >= 9 THEN
          numok% = numok% + 1
          okclass%(numok%) = 4
     END IF
END IF

IF ability%(5) >= 9 THEN
          numok% = numok% + 1
          okclass%(numok%) = 5
END IF

IF race% = 2 OR race% = 4 OR race% = 6 THEN
     IF ability%(4) >= 12 AND ability%(6) >= 15 THEN
          numok% = numok% + 1
          okclass%(numok%) = 6
     END IF
END IF

IF ability%(2) >= 9 THEN
     numok% = numok% + 1
     okclass%(numok%) = 7
END IF

IF race% = 4 OR race% = 6 THEN
     IF ability%(2) >= 12 AND ability%(4) >= 13 AND ability%(6) >= 15 THEN
          numok% = numok% + 1
          okclass%(numok%) = 8
     END IF
END IF

CLS
PRINT "ABILITY SCORES:"
FOR i% = 1 TO 6
     PRINT ability$(i%), ability%(i%)
NEXT i%
PRINT
PRINT "Do you want to be a "
FOR i% = 1 TO numok%
     IF prime%(okclass%(i%)) = -1 THEN
          PRINT i%; ") "; UCASE$(class$(okclass%(i%)))
     ELSE
          PRINT i%; ") "; class$(okclass%(i%))
     END IF
NEXT i%
150

PRINT
PRINT "CAPS SIGNIFY YOUR ABILITY SCORES HAVE MET PRIME"
PRINT "REQUISITE QUALIFICATIONS FOR THIS CLASS."
PRINT
PRINT "Enter the number (1 to"; numok%; ")";
INPUT a%
IF a% = 0 THEN END
IF a% > numok% THEN GOTO 150

class% = okclass%(a%)
primereq% = prime%(class%)

END SUB

SUB hits
IF class% = 1 OR class% = 2 OR class% = 3 THEN
     hit% = rolldice%(1, 10)
     wp% = 4
     nwp% = 3
     money% = rolldice%(5, 4) * 10
END IF

IF class% = 4 THEN
     hit% = rolldice%(1, 4)
     wp% = 1
     nwp% = 4
     money% = (rolldice%(1, 4) + 1) * 10
END IF

IF class% = 5 OR class% = 6 THEN
     hit% = rolldice%(1, 8)
     wp% = 2
     nwp% = 4
     money% = rolldice%(3, 6) * 10
END IF

IF class% = 7 OR class% = 8 THEN
     hit% = rolldice%(1, 6)
     wp% = 2
     nwp% = 3
     money% = rolldice%(2, 6) * 10
END IF

END SUB

SUB mss
LPRINT "    AD&D Character Generator - Spell Sheet - Copyright (c) Danny Abramson"
LPRINT "Spells per Level:   1st     2nd    3rd    4th    5th    6th    7th    8th    9th"
LPRINT
FOR i% = 1 TO 9
        LPRINT "SPELL:_______________________________  School/Sphere:__________________________"
        LPRINT "Level:_________ Range:_______________  Components:_________  Duration:_________"
        LPRINT "Casting Time:__ Area of Effect:______  Saving Throw:_______  Reversible?:______"
        LPRINT "Effect:________________________________________________________________________"
        LPRINT "__________________________________________________________________Pages:_______"
        LPRINT ""
NEXT i%
LPRINT CHR$(12)
END SUB

SUB races
DIM okrace%(6)

DIM basemh%(6)
DIM basefh%(6)
DIM modhn%(6)
DIM modhs%(6)
basemh%(1) = 43
basemh%(2) = 55
basemh%(3) = 38
basemh%(4) = 60
basemh%(5) = 32
basemh%(6) = 60
basefh%(1) = 41
basefh%(2) = 50
basefh%(3) = 36
basefh%(4) = 58
basefh%(5) = 30
basefh%(6) = 59
modhn%(1) = 1
modhn%(2) = 1
modhn%(3) = 1
modhn%(4) = 2
modhn%(5) = 2
modhn%(6) = 2
modhs%(1) = 10
modhs%(2) = 10
modhs%(3) = 6
modhs%(4) = 6
modhs%(5) = 8
modhs%(6) = 10

DIM basemw%(6)
DIM basefw%(6)
DIM modwn%(6)
DIM modws%(6)
basemw%(1) = 130
basemw%(2) = 90
basemw%(3) = 72
basemw%(4) = 110
basemw%(5) = 52
basemw%(6) = 140
basefw%(1) = 105
basefw%(2) = 70
basefw%(3) = 68
basefw%(4) = 85
basefw%(5) = 48
basefw%(6) = 100
modwn%(1) = 4
modwn%(2) = 3
modwn%(3) = 5
modwn%(4) = 3
modwn%(5) = 5
modwn%(6) = 6
modws%(1) = 10
modws%(2) = 10
modws%(3) = 4
modws%(4) = 12
modws%(5) = 4
modws%(6) = 10

DIM basea%(6)
DIM modan%(6)
DIM modas%(6)
basea%(1) = 40
basea%(2) = 100
basea%(3) = 60
basea%(4) = 15
basea%(5) = 20
basea%(6) = 15
modan%(1) = 5
modan%(2) = 5
modan%(3) = 3
modan%(4) = 1
modan%(5) = 3
modan%(6) = 1
modas%(1) = 6
modas%(2) = 6
modas%(3) = 12
modas%(4) = 6
modas%(5) = 4
modas%(6) = 4

numokraces% = 0

IF ability%(1) > 7 AND ability%(2) < 18 AND ability%(3) > 10 AND ability%(6) < 18 THEN
     numokraces% = 1
     okrace%(1) = 1
END IF
IF ability%(2) > 5 AND ability%(3) > 6 AND ability%(4) > 7 AND ability%(6) > 7 THEN
     numokraces% = numokraces% + 1
     okrace%(numokraces%) = 2
END IF
IF ability%(1) > 5 AND ability%(3) > 7 AND ability%(4) > 5 THEN
     numokraces% = numokraces% + 1
     okrace%(numokraces%) = 3
END IF
IF ability%(2) > 5 AND ability%(3) > 5 AND ability%(4) > 3 THEN
     numokraces% = numokraces% + 1
     okrace%(numokraces%) = 4
END IF
IF ability%(1) > 6 AND ability%(2) > 6 AND ability%(3) > 9 AND ability%(4) > 5 AND ability%(5) < 18 THEN
     numokraces% = numokraces% + 1
     okrace%(numokraces%) = 5
END IF
numokraces% = numokraces% + 1
okrace%(numokraces%) = 6

CLS
PRINT "Do you want to be a "
FOR i% = 1 TO numokraces%
     PRINT i%; ") "; race$(okrace%(i%))
NEXT i%
50

PRINT
PRINT "Enter the number (1 to"; numokraces%; ")";
INPUT a%
IF a% = 0 THEN END
IF a% > numokraces% THEN GOTO 50

race% = okrace%(a%)

SELECT CASE race%
   CASE 1
     ability%(3) = ability%(3) + 1
     ability%(6) = ability%(6) - 1
   CASE 2
     ability%(2) = ability%(2) + 1
     ability%(3) = ability%(3) - 1
   CASE 3
     ability%(4) = ability%(4) + 1
     ability%(5) = ability%(5) - 1
   CASE 5
     ability%(2) = ability%(2) + 1
     ability%(1) = ability%(1) - 1
END SELECT
51
INPUT "Is your character Male (M) or Female (F) "; gender$
gender$ = UCASE$(gender$)
IF gender$ <> "M" AND gender$ <> "F" GOTO 51
INPUT "What is your character's name "; name$
INPUT "What is your character's hair color "; hair$
INPUT "What color is your character's eyes "; eyes$
INPUT "What is your character's religion "; religion$
INPUT "How many siblings does your character have "; siblings&
INPUT "What is your character's social class "; social$


IF gender$ = "M" THEN
     height% = basemh%(race%) + rolldice%(modhn%(race%), modhs%(race%))
     weight% = basemw%(race%) + rolldice%(modwn%(race%), modws%(race%))
     gender$ = "Male"
END IF

IF gender$ = "F" THEN
     height% = basefh%(race%) + rolldice%(modhn%(race%), modhs%(race%))
     weight% = basefw%(race%) + rolldice%(modwn%(race%), modws%(race%))
     gender$ = "Female"
END IF

age% = basea%(race%) + rolldice%(modan%(race%), modas%(race%))

END SUB

FUNCTION roll5%
DIM die%(4)

FOR j% = 1 TO 4
     die%(j%) = INT(RND * 6) + 1
NEXT j%
low% = 1
FOR j% = 2 TO 4
     IF die%(j%) < die%(low%) THEN
     low% = j%
     END IF
NEXT j%
roll5% = die%(1) + die%(2) + die%(3) + die%(4) - die%(low%)

END FUNCTION

FUNCTION rolldice% (num%, sides%)
roll% = 0
FOR i% = 1 TO num%
     roll% = roll% + INT(RND * sides%) + 1
NEXT i%
rolldice% = roll%
END FUNCTION

SUB save
INPUT "Enter an 8 letter or less nickname for your charcacter:  ", new$
OPEN new$ FOR OUTPUT AS 1
55
66
CLS
REM PRINT #1, "                       YOUR CHARACTER SUMMARY"
REM PRINT #1,
REM PRINT #1,
REM PRINT #1, "ABILITY SCORES:", "SAVING THROWS:"
FOR i% = 1 TO 5
     REM PRINT #1, ability$(i%), ability%(i%), savthrow$(i%), savthrow%(i%)
NEXT i%
REM PRINT #1, ability$(6), ability%(6)
REM PRINT #1,
REM PRINT #1, "NAME  : ", name$
IF primereq% = -1 THEN
     REM PRINT #1, "CLASS : ", class$(class%); ; " (Prime Requisites Met)"
ELSE
     REM PRINT #1, "CLASS : ", class$(class%)
END IF
REM PRINT #1, "ALIGNMENT: ", align$(align%)
REM PRINT #1, "THAC0: ", 20
REM PRINT #1, "HIT POINTS: ", hit%
REM PRINT #1, "BASE MOVEMENT:"; move%
REM PRINT #1, "WEAPON PROFICIENCIES   : "; wp%
REM PRINT #1, "NONWEAPON PROFICIENCIES: "; nwp%
REM PRINT #1, "STARTING FUNDS:"; money%; " Gold Pieces"
REM PRINT #1,
REM PRINT #1,
REM PRINT #1,
REM PRINT #1, "HAIR:", hair$
REM PRINT #1, "EYES:", eyes$
REM PRINT #1, "RELIGION:", religion$
REM PRINT #1, "SIBLINGS:", siblings&
REM PRINT #1, "SOCIAL CLASS:", social$
REM PRINT #1, "RACE  : ", race$(race%)
REM PRINT #1, "GENDER: ", gender$
REM PRINT #1, "HEIGHT: ", height%; " inches,  ("; height% \ 12; "feet, "; height% MOD 12; "inches)"
REM PRINT #1, "WEIGHT: ", weight%; " lbs."
REM PRINT #1, "AGE   : ", age%; " years"
REM PRINT #1,
REM PRINT #1,
PRINT #1, class%, height%, weight%, age%, race%, primereq%
PRINT #1, align%, hit%, move%, wp%, nwp%, money%, siblings&
PRINT #1, gender$
PRINT #1, name$
PRINT #1, hair$
PRINT #1, eyes$
PRINT #1, religion$
PRINT #1, social$
PRINT #1, ability%(1)
PRINT #1, ability%(2)
PRINT #1, ability%(3)
PRINT #1, ability%(4)
PRINT #1, ability%(5)
PRINT #1, ability%(6)
PRINT #1, savthrow%(1)
PRINT #1, savthrow%(2)
PRINT #1, savthrow%(3)
PRINT #1, savthrow%(4)
PRINT #1, savthrow%(5)
END SUB

SUB saved
550
PRINT "Enter the 8 letter or less nickname"
INPUT "you chose for your character:  ", name$
OPEN name$ FOR INPUT AS 2
CLS
INPUT #2, class%, height%, weight%, age%, race%, primereq%
INPUT #2, align%, hit%, move%, wp%, nwp%, money%, siblings&
INPUT #2, gender$
INPUT #2, name$
INPUT #2, hair$
INPUT #2, eyes$
INPUT #2, religion$
INPUT #2, social$
INPUT #2, ability%(1)
INPUT #2, ability%(2)
INPUT #2, ability%(3)
INPUT #2, ability%(4)
INPUT #2, ability%(5)
INPUT #2, ability%(6)
INPUT #2, savthrow%(1)
INPUT #2, savthrow%(2)
INPUT #2, savthrow%(3)
INPUT #2, savthrow%(4)
INPUT #2, savthrow%(5)

PRINT "                       YOUR CHARACTER SUMMARY"
PRINT
PRINT
PRINT "ABILITY SCORES:", "SAVING THROWS:"
FOR i% = 1 TO 5
     PRINT ability$(i%), ability%(i%), savthrow$(i%), savthrow%(i%)
NEXT i%
PRINT ability$(6), ability%(6)
PRINT
PRINT "NAME  : ", name$
IF primereq% = -1 THEN
     PRINT "CLASS : ", class$(class%); ; " (Prime Requisites Met)"
ELSE
     PRINT "CLASS : ", class$(class%)
END IF
PRINT "ALIGNMENT: ", align$(align%)
PRINT "THAC0: ", 20
PRINT "HIT POINTS: ", hit%
PRINT "BASE MOVEMENT:"; move%
PRINT "WEAPON PROFICIENCIES   : "; wp%
PRINT "NONWEAPON PROFICIENCIES: "; nwp%
PRINT "STARTING FUNDS:"; money%; " Gold Pieces"
PRINT
INPUT "Press Enter for more"; d%
CLS
PRINT
PRINT
PRINT "HAIR:", hair$
PRINT "EYES:", eyes$
PRINT "RELIGION:", religion$
PRINT "SIBLINGS:", siblings&
PRINT "SOCIAL CLASS:", social$
PRINT "RACE  : ", race$(race%)
PRINT "GENDER: ", gender$
PRINT "HEIGHT: ", height%; " inches,  ("; height% \ 12; "feet, "; height% MOD 12; "inches)"
PRINT "WEIGHT: ", weight%; " lbs."
PRINT "AGE   : ", age%; " years"
PRINT
PRINT
INPUT "Would you like to see this information again (Y, N)"; again$
again$ = UCASE$(again$)
IF again$ = "Y" THEN GOTO 550 ELSE
PRINT
INPUT "Would you like this information printed out (Y, N)"; lprint$
lprint$ = UCASE$(lprint$)
IF lprint$ = "Y" THEN
        LPRINT "                 AD&D CHARACTER GENERATOR CHARACTER SUMMARY"
        LPRINT
        LPRINT
        LPRINT "ABILITY SCORES:", "SAVING THROWS:"
        FOR i% = 1 TO 5
                LPRINT ability$(i%), ability%(i%), savthrow$(i%), savthrow%(i%)
        NEXT i%
        LPRINT ability$(6), ability%(6)
        LPRINT
        LPRINT "NAME  : ", name$
        IF primereq% = -1 THEN
               LPRINT "CLASS : ", class$(class%); ; " (Prime Requisites Met)"
        ELSE
               LPRINT "CLASS : ", class$(class%)
        END IF
        LPRINT "ALIGNMENT: ", align$(align%)
        LPRINT "THAC0: ", 20
        LPRINT "HIT POINTS: ", hit%
        LPRINT "BASE MOVEMENT:"; move%
        LPRINT "WEAPON PROFICIENCIES   : "; wp%
        LPRINT "NONWEAPON PROFICIENCIES: "; nwp%
        LPRINT "STARTING FUNDS:"; money%; " Gold Pieces"
        LPRINT
        LPRINT
        LPRINT "HAIR:", hair$
        LPRINT "EYES:", eyes$
        LPRINT "RELIGION:", religion$
        LPRINT "SIBLINGS:", siblings&
        LPRINT "SOCIAL CLASS:", social$
        LPRINT "RACE  : ", race$(race%)
        LPRINT "GENDER: ", gender$
        LPRINT "HEIGHT: ", height%; " inches,  ("; height% \ 12; "feet, "; height% MOD 12; "inches)"
        LPRINT "WEIGHT: ", weight%; " lbs."
        LPRINT "AGE   : ", age%; " years"
        LPRINT CHR$(12)
END IF
PRINT
IF class% = 4 OR 5 OR 6 OR 7 OR 8 THEN
        INPUT "Would you like to print a spell sheet (Y, N)", ss$
        IF ss$ = "y" THEN mss
        IF ss$ = "Y" THEN mss
END IF
PRINT
INPUT "Would you like to create another character (Y, N)", create$
IF create$ = "y" THEN GOTO 101
IF create$ = "Y" THEN GOTO 101
CLS
SYSTEM
101
END SUB

SUB savthrows

IF class% = 1 OR class% = 2 OR class% = 3 THEN
     savthrow%(1) = 14
     savthrow%(2) = 16
     savthrow%(3) = 15
     savthrow%(4) = 17
     savthrow%(5) = 17
END IF

IF class% = 4 THEN
     savthrow%(1) = 14
     savthrow%(2) = 11
     savthrow%(3) = 13
     savthrow%(4) = 15
     savthrow%(5) = 12
END IF

IF class% = 5 OR class% = 6 THEN
     savthrow%(1) = 10
     savthrow%(2) = 14
     savthrow%(3) = 13
     savthrow%(4) = 16
     savthrow%(5) = 15
END IF

IF class% = 7 OR class% = 8 THEN
     savthrow%(1) = 14
     savthrow%(2) = 11
     savthrow%(3) = 13
     savthrow%(4) = 15
     savthrow%(5) = 12
END IF

SELECT CASE ability%(3)

     CASE IS > 17
          savmod% = 5
     CASE IS > 13
          savmod% = 4
     CASE IS > 10
          savmod% = 3
     CASE IS > 6
          savmod% = 2
     CASE ELSE
          savmod% = 1

END SELECT

IF race% = 1 OR race% = 3 THEN
        savthrow%(1) = savthrow%(1) - savmod%
        savthrow%(2) = savthrow%(2) - savmod%
        savthrow%(5) = savthrow%(5) - savmod%
END IF

END SUB

